#!/usr/bin/perl -w
#default, in future can be changed in skeleton file
$input_file=$ARGV[0];
$line_no=0;

$lex_l2r_fname="c2txt.lex";
$y_l2r_fname="c2txt.y";
$lex_r2l_fname="txt2c.lex";
$y_r2l_fname="txt2c.y";

$y_l2r_skel_fname="c2txt.y.skel";
$y_r2l_skel_fname="txt2c.y.skel";

$lex_l2r_skel_fname="c2txt.lex.skel";
$lex_r2l_skel_fname="txt2c.lex.skel";

$lex_l="";

$y_l_header="";
$y_l="";

$lex_r="";

$y_r_header="";
$y_r="";

%left_strings=();
%right_strings=();
$strings_serial=0;

%left_decl=();
%right_decl=();

%c_code=();

sub parse_sentence {
  my($s)=$_[0];
  my($i)=0;
  my(@sentence)=();
  while(length($s)>0) {
    if($s=~s/^\[(.*?)\](.*)/$2/) {
      $sentence[$i++]="var:$1";
    } else {
      my($s2)="";
      my($flag);
      do {
        $flag=0;
        #everything until '[' or '\'
        if($s=~s/^([^\[\\]+)(.*)/$2/) {$s2.=$1;$flag=1;}
        #'\' followed with '[' or ']'
        elsif($s=~s/^\\([\[\]])(.*)/$2/) {$s2.=$1;$flag=1;}
        #'\' in the beginning
        elsif($s=~s/^(\\)(.*)/$2/) {$s2.=$1;$flag=1;}
      } while($flag);
      $sentence[$i++]="str:$s2";
    }
  }
  return @sentence;
}

sub analyse_c_code {
  my($c_code)=$_[0];
  my($variable_ref)=$_[1];
  my(@sentence)=&parse_sentence($c_code);
  my($args)=$#sentence+1;
  my($res)="";
  my($i);
  for($i=0;$i<$args;$i++) {
    my($type,$str)=split(":",$sentence[$i],2);
    if($type eq "var") {
      my($v)=$$variable_ref{$str};
      if(defined($v)) {$res.="$v";}
      else {print STDERR "$input_file:$line_no: variable $str not defined\n";}
    } else { #str
      $res.=$str;
    }
  }
  return $res;
}

sub add_rule1 {
  my($name)=$_[0];
  my($left)=$_[1];
  my($right_ref)=$_[2];
  my($strings_ref)=$_[3];
  my($decl_ref)=$_[4];
  my($res_y_header)="";
  my($res_y)="";
  my($res_lex)="";
  my(@sentence)=&parse_sentence($left);
  my($args)=$#sentence+1;
  my($free_count)=$args;
  #print "-------\n";
  #print "$name: {$left} => {$right_ref}\n";
  $res_y.="$name:";
  my(%variables)=();
  my($start_condition)="INITIAL";
  my($i,$j);
  for($i=0;$i<$args;$i++) {
    my($type,$str)=split(":",$sentence[$i],2);
    if($type eq "var") {
      if($str=~/^(.*)\./) {$res_y.=" $1";}
      else {$res_y.=" $str";}
      $variables{$str}="\$" . ($i+1);
    } else { #str
      my($decl_ind)="";
      my($set_start_cond)="";
      if($str=~/^%BEGIN\(([^%\)]+)\)%(.*)/) {
        $set_start_cond=$1;
        $str=$2;
      }
      if($str=~/^(%[^%]*)%(.*)/) {
        $decl_ind=$1;
        $str=$2;
      }
      $str=~s/\\/\\\\/g;
      $str=~s/"/\\"/g;
      $str="\"$str\"";
      if($start_condition cmp "INITIAL") {$str="<$start_condition>$str";}
      my($str_name)=$$strings_ref{$str};
      if(!defined($str_name)) {
        if(length($str)==3) {$str_name="'" . substr($str,1,1) . "'";}
        else {$str_name=uc($name) . "_" . ++$strings_serial;}
        $$strings_ref{$str}=$str_name;
        $res_y_header.="%token $str_name\n";

        if($decl_ind cmp "") {
          $$decl_ref{$decl_ind}.=" $str_name";
        }

        if($set_start_cond cmp "") {
          $res_lex.="$str {BEGIN($set_start_cond); CSTR; return $str_name;}\n";
        } else {
          $res_lex.="$str {CSTR; return $str_name;}\n";
        }
      }
      if($set_start_cond cmp "") {$start_condition=$set_start_cond;}
      $res_y.=" $str_name";
    }
  }
  my($right);
  my($right_num)=$#$right_ref+1;
  $res_y.=" {\n";
  if($right_num>1) {$res_y.="\tswitch(rand()%$right_num) {\n";}
  for($j=0;$j<$right_num;$j++) {
    $right=$$right_ref[$j];
    $res_y.="\t";
    if($right_num>1) {$res_y.="\tcase $j: ";}
    @sentence=&parse_sentence($right);
    $args=$#sentence+1;
    $res_y.="\$\$=astr($args";
    for($i=0;$i<$args;$i++) {
      my($type,$str)=split(":",$sentence[$i],2);
      if($type eq "var") {
        #$res_y.=",\$" . ($i+1);
        my($v)=$variables{$str};
        if(defined($c_code{$str})) {
          $res_y.="," . &analyse_c_code($c_code{$str},\%variables);
        } elsif(defined($v)) {$res_y.=",$v";}
        else {print STDERR "$input_file:$line_no: variable $str not defined\n";}
      } else { #str
        $str=~s/^(%[^%]*)%(.*)$/$2/;
        $str=~s/\\/\\\\/g;
        $str=~s/"/\\"/g;
        $res_y.=",\"$str\"";
      }
    }
    $res_y.=");";
    if($right_num>1) {$res_y.="break;";}
    $res_y.="\n";
  }
  if($right_num>1) {$res_y.="\t}\n";}
  $res_y.="\t";
  for($i=1;$i<=$free_count;$i++) {
    $res_y.="free_chk(\$$i,\"$name:\$$i\");";
  }
  $res_y.="\n}\n;\n\n";
  return ($res_y_header,$res_y,$res_lex);
}

sub add_rule {
  my($name)=$_[0];
  my($left)=$_[1];
  my($right_ref)=$_[2];
  my($yh,$y,$l)=&add_rule1($name,$left,$right_ref,\%left_strings,\%left_decl);
  $y_l_header.=$yh;
  $y_l.=$y;
  $lex_l.=$l;
  my($right);
  foreach $right (@$right_ref) {
    ($yh,$y,$l)=&add_rule1($name,$right,[$left],\%right_strings,\%right_decl);
    $y_r_header.=$yh;
    $y_r.=$y;
    $lex_r.=$l;
  }
}

sub add_c_rule {
  my($name)=$_[0];
  my($body)=$_[1];
  $c_code{$name}=$body;
#  $y_l.="$name: /*empty*/\n;\n\n";
#  $y_r.="$name: /*empty*/\n;\n\n";
}

while(<>) {
  eval;
}

sub write_y {
  #$y_l2r_fname,$y_l2r_skel_fname,$y_l_header,$y_l
  my($fname)=$_[0];
  my($skel_fname)=$_[1];
  my($declarations)=$_[2];
  my($rules)=$_[3];
  my($decl_ref)=$_[4];
  open(OUT,">$fname") || die "Cannot open $_[0]\n";
  open(IN,"$skel_fname");
  while(<IN>) {
    if(/^%%declarations/) {print OUT $declarations;}
    elsif(/^%%rules/) {print OUT $rules;}
    elsif(/^(%.*)$/) {
      if($$decl_ref{$1}) {print OUT "$1$$decl_ref{$1}\n";}
      else {print OUT;}
    } else {print OUT;}
  }
  close(IN);
  close(OUT);
}

sub write_lex {
  #$lex_l2r_fname,$lex_l2r_skel_fname,$lex_l
  open(OUT,">$_[0]") || die "Cannot open $_[0]\n";
  open(IN,"$_[1]");
  while(<IN>) {
    if(/^%%patterns/) {print OUT $_[2];}
    else {print OUT;}
  }
  close(IN);
  close(OUT);
}

&write_y($y_l2r_fname,$y_l2r_skel_fname,$y_l_header,$y_l,\%left_decl);
&write_lex($lex_l2r_fname,$lex_l2r_skel_fname,$lex_l);


&write_y($y_r2l_fname,$y_r2l_skel_fname,$y_r_header,$y_r,\%right_decl);
&write_lex($lex_r2l_fname,$lex_r2l_skel_fname,$lex_r);

