/* grammar for generating x2x translators */

%{
#include "x2x.h"
#include <string.h>
#include <stdlib.h>
int yyerror(char *str);
int yylex();
char *name=NULL;
%}

/* BISON Declarations */
%token SKELETON_VERSION_1
%token NAME STRING ':' '{' '}' TRANSLATION '|' ';' '[' ']' OR
%token PERL_BEGIN PERL_END
%token OUTPUT_C

/* Grammar follows */
%%
input: SKELETON_VERSION_1
     | input statement
     | error {fprintf(stderr,"%s:%i: parse error\n",parse_fname,line_num);}
;

statement: rules
         | perl_code
         | c_output
;

rules: NAME {name=strdup($1);} ':' translation_list ';'
;

translation_list: translation
                | translation '|' translation_list

sentence: /*empty*/ {$$=astr(1,"");}
        | sentence STRING {$$=astr(2,$1,$2);
            free_chk($1,"sentence:sentence"); 
            free_chk($2,"sentence:STRING"); 
            /*printf("<%s>\n",$1);*/
        }
;

whole_sentence: '{' sentence '}' {$$=$2;}
;

sentences: whole_sentence
         | sentences OR whole_sentence {$$=astr(3,$1,"},q{",$3);
            free_chk($1,"sentences:sentences"); 
            free_chk($3,"sentences:sentence"); 
            /*printf("<%s>\n",$1);*/
        }
;

translation: '{' sentence '}' TRANSLATION sentences {
  printf("$line_no=%i; &add_rule(q{%s},q{%s},[q{%s}]);\n",line_num,name,$2,$5);
  free_chk($2,"translation:sentence");
  free_chk($5,"translation:sentences");
}
;

perl_code: PERL_BEGIN sentence PERL_END {
  printf("#Included code:\n%s\n#End of included code\n",$2);
}
;

c_output: NAME '.' OUTPUT_C ':' '{' sentence '}' ';' {
  printf("$line_no=%i; &add_c_rule(q{%s},q{%s});\n",line_num,$1,$6);
}
;

%%

void init()
{
#if DEBUG
  debStr=malloc(DEB_STR_SIZE);
  if(!debStr) {
    fprintf(stderr,"Not enough memory\n");
    exit(-1);
  }
#endif
#if 0
  read_names("names.lst");
  printf("<%s>\n",(add_id("foo","bar"),""));
#endif
  printf("$input_file=\"%s\";\n",parse_fname);
  /*yydebug=1;*/
}
