#include "COPYRIGHT" /* It will be included in almost every file ;-) */

#define TRUE 1
#define FALSE 0

#define CMEM(v) if(!(v)) {fprintf(stderr,"Not enough memory!\n");exit(-2);}

#define YYSTYPE char*
#define CSTR yylval=strdup(yytext);if(yydebug) fprintf(stderr,"LEX:%i:<%s>\n",__LINE__,yytext);
#define RSTR(s) yylval=strdup((s));
#define E strdup("")

char *poem2nstr(char *poem);
char *num2poem(unsigned long int n);
char *nstr2hexstr(char *num_str);
char *hex2nstr(char *hex_str);
unsigned long int hex2n(char *hex_str);

#define DEBUG TRUE
#if DEBUG
#define D(p) do {printf("{D:");p;printf(" }");} while(0)
#define DEB_STR_SIZE 1000 /* FIXME: buffer owerflow, if too big identifiers */
extern char *debStr;
#define D0(f) (snprintf(debStr,DEB_STR_SIZE,f),debStr)
#define D1(f,a1) (snprintf(debStr,DEB_STR_SIZE,f,a1),debStr)
#define D2(f,a1,a2) (snprintf(debStr,DEB_STR_SIZE,f,a1,a2),debStr)
#define D3(f,a1,a2,a3) (snprintf(debStr,DEB_STR_SIZE,f,a1,a2,a3),debStr)
#define D4(f,a1,a2,a3,a4) (snprintf(debStr,DEB_STR_SIZE,f,a1,a2,a3,a4),debStr)
#define D5(f,a1,a2,a3,a4,a5) (snprintf(debStr,DEB_STR_SIZE,f,a1,a2,a3,a4,a5),debStr)
#else //!DEBUG
#define D(p)
#define D0(f) ""
#define D1(f,a1) ""
#define D2(f,a1,a2) ""
#define D3(f,a1,a2,a3) ""
#define D4(f,a1,a2,a3,a4) ""
#define D5(f,a1,a2,a3,a4,a5) ""
#endif

extern char *C_txt,*C_add;
#define C(txt,add) C_txt=(txt);C_add=(add);\
  if(strcmp(C_txt,C_add)) fprintf(stderr,"D:Names differ %s %s\n",C_txt,C_add);

/* FIXME: use some C++ and some string class instead:
   this wastes huge amount of memory
   or make almost every string dynamically allocated
 */

#define MAX_NAMES 87
int read_names(char *file_name);
char *add_name(char *name);
char *add_id(char *id, char *ntype);
char *get_id(char *name);
char *get_name(char *id);
char *get_type(char *id);
void init();

char *astr(int count, ...);
void free_chk(void *ptr, char *msg);

extern int line_num;
extern char *parse_fname;
extern int yydebug;
